## shiboken 0.5.0

=== CMakeLists.txt ===
include(icecc.cmake)
project(shiboken)

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules/
                      ${CMAKE_MODULE_PATH})

find_package(Qt4 4.5.0 REQUIRED)
find_package(ApiExtractor 0.8 REQUIRED)
find_package(GeneratorRunner 0.6.1 REQUIRED)
find_package(PythonLibs REQUIRED)
find_package(PythonInterpWithDebug REQUIRED)

add_definitions(${QT_DEFINITIONS})

option(AVOID_PROTECTED_HACK "Avoid protected hack on generated bindings." FALSE)
option(BUILD_TESTS "Build tests." TRUE)
option(ENABLE_VERSION_SUFFIX "Used to use current version in suffix to generated files. This is used to allow multiples versions installed simultaneous." FALSE)

if(MSVC)
    set(CMAKE_CXX_FLAGS "/Zc:wchar_t- /GR /EHsc /DWIN32 /D_WINDOWS /D_SCL_SECURE_NO_WARNINGS")
else()
    if(CMAKE_HOST_UNIX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fvisibility=hidden -Wno-strict-aliasing")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "-g")
    option(ENABLE_GCC_OPTIMIZATION "Enable specific GCC flags to optimization library size and performance. Only available on Release Mode" 0)
    if(ENABLE_GCC_OPTIMIZATION)
        set(CMAKE_BUILD_TYPE Release)
        set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -Os -Wl,-O1")
        if(NOT CMAKE_HOST_APPLE)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--hash-style=gnu")
        endif()
    endif()
endif()

if (WIN32)
    set(PATH_SEP "\;")
else()
    set(PATH_SEP ":")
endif()

if(WIN32 OR AVOID_PROTECTED_HACK)
    message(STATUS "Avoiding protected hack!")
    add_definitions("-DAVOID_PROTECTED_HACK")
else()
    message(STATUS "Using protected hack!")
endif()

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)

set(shiboken_MAJOR_VERSION "0")
set(shiboken_MINOR_VERSION "5")
set(shiboken_MICRO_VERSION "0")
set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
if(ENABLE_VERSION_SUFFIX)
    set(shiboken_SUFFIX "-${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}")
else()
    set(shiboken_SUFFIX "")
endif()

set(shiboken_SRC
cppgenerator.cpp
headergenerator.cpp
overloaddata.cpp
shiboken.cpp
shibokengenerator.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${APIEXTRACTOR_INCLUDE_DIR}
                    ${GENERATORRUNNER_INCLUDE_DIR}
                    ${QT_INCLUDE_DIR}
                    ${QT_QTCORE_INCLUDE_DIR})

add_library(shiboken_generator SHARED ${shiboken_SRC})
set_property(TARGET shiboken_generator PROPERTY PREFIX "")

target_link_libraries(shiboken_generator
                      ${APIEXTRACTOR_LIBRARY}
                      ${GENERATORRUNNER_LIBRARY}
                      ${QT_QTCORE_LIBRARY})

add_executable(shiboken main.cpp)
set_target_properties(shiboken PROPERTIES OUTPUT_NAME shiboken${shiboken_SUFFIX})
target_link_libraries(shiboken ${QT_QTCORE_LIBRARY})

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Detect if the python libs were compiled in debug mode
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; \\
        print sysconfig.get_config_var('Py_DEBUG')"
    OUTPUT_VARIABLE PY_DEBUG
    OUTPUT_STRIP_TRAILING_WHITESPACE)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    if(NOT PYTHON_DEBUG_LIBRARIES)
        message(FATAL_ERROR "Python debug library not found. Try compile shiboken with -DCMAKE_BUILD_TYPE=Release")
    endif()
    if(NOT PY_DEBUG)
        message(WARNING "Compiling shiboken with debug enabled, but the python executable was not compiled with debug support.")
    else()
        add_definitions("-DPy_DEBUG")
    endif()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_DEBUG_LIBRARIES})
else()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_LIBRARIES})
    add_definitions("-DNDEBUG")
endif()

if (BUILD_TESTS)
    enable_testing()
endif()

add_subdirectory(libshiboken)

if (BUILD_TESTS)
    add_subdirectory(tests)
endif()
add_subdirectory(data)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
add_custom_target(dist
    COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&
            git log > "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}/ChangeLog" &&
            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar --output="${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            tar -C "${CMAKE_BINARY_DIR}" --owner=root --group=root -r "${ARCHIVE_NAME}/ChangeLog" -f "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            bzip2 -f9 "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_dependencies(shiboken shiboken_generator)

install(TARGETS shiboken_generator DESTINATION "${GENERATORRUNNER_PLUGIN_DIR}")
install(TARGETS shiboken DESTINATION bin)

=== data/CMakeLists.txt ===
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfigVersion.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/shiboken.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/shiboken${shiboken_SUFFIX}.pc" @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${shiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${shiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/shiboken${shiboken_SUFFIX}.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

=== libshiboken/CMakeLists.txt ===
project(libshiboken)
#Find installed sparsehash
find_path(SPARSEHASH_INCLUDE_PATH sparseconfig.h PATH_SUFFIXES "/google/sparsehash")
if(SPARSEHASH_INCLUDE_PATH)
    message(STATUS "Using system hash found in: ${SPARSEHASH_INCLUDE_PATH}")
else()
    set(SPARSEHASH_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/ext/sparsehash)
endif()

add_definitions(-DWITH_THREAD)
set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
set(libshiboken_SOVERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}")

set(libshiboken_SRC
basewrapper.cpp
gilstate.cpp
helper.cpp
pyenum.cpp
bindingmanager.cpp
threadstatesaver.cpp
typeresolver.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${SPARSEHASH_INCLUDE_PATH})
add_library(libshiboken SHARED ${libshiboken_SRC})
target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}"
                                             VERSION ${libshiboken_VERSION}
                                             SOVERSION ${libshiboken_SOVERSION}
                                             DEFINE_SYMBOL LIBSHIBOKEN_EXPORTS)

install(FILES
        autodecref.h
        basewrapper.h
        bindingmanager.h
        conversions.h
        gilstate.h
        helper.h
        pyenum.h
        python25compat.h
        sbkdbg.h
        shiboken.h
        shibokenmacros.h
        threadstatesaver.h
        typeresolver.h
        DESTINATION include/shiboken${shiboken_SUFFIX})
install(TARGETS libshiboken EXPORT shiboken
                            LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                            ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
                            RUNTIME DESTINATION bin)

=== tests/CMakeLists.txt ===
add_subdirectory(libsample)
add_subdirectory(libother)
add_subdirectory(samplebinding)
add_subdirectory(otherbinding)

file(GLOB TEST_FILES samplebinding/*_test.py otherbinding/*_test.py)

set(test_blacklist "")

find_package(PythonInterp REQUIRED)
if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

if(CMAKE_VERSION VERSION_LESS 2.8)
    message("CMake version greater than 2.8 necessary to run tests")
else()
    if(WIN32)
        set(TEST_PYTHONPATH     "${sample_BINARY_DIR};${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{PATH};${libsample_BINARY_DIR};${libother_BINARY_DIR};${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "PATH")
	    string(REPLACE "\\" "/" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
	    string(REPLACE "\\" "/" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")

	    string(REPLACE ";" "\\;" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
	    string(REPLACE ";" "\\;" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
    else()
        set(TEST_PYTHONPATH     "${sample_BINARY_DIR}:${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{LD_LIBRARY_PATH}:${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "LD_LIBRARY_PATH")
    endif()

    foreach(test_file ${TEST_FILES})
        string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
        list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
        add_test(${CMAKE_MATCH_1} ${PYTHON_EXECUTABLE} ${test_file})
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};${LIBRARY_PATH_VAR}=${TEST_LIBRARY_PATH}")
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
        if (${expect_fail} GREATER -1)
            set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
        endif()
    endforeach()
endif()

=== tests/otherbinding/CMakeLists.txt ===
project(other)

set(other_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_other.xml
)

set(other_SRC
${CMAKE_CURRENT_BINARY_DIR}/other/extendsnoimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/number_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherderived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/othermultiplederived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherobjecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/other_module_wrapper.cpp
)

add_custom_command(OUTPUT ${other_SRC}
COMMAND ${GENERATORRUNNER_BINARY} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
        --include-paths=${libother_SOURCE_DIR}${PATH_SEP}${libsample_SOURCE_DIR}${PATH_SEP}${libsample_SOURCE_DIR}/..
        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}${PATH_SEP}${sample_SOURCE_DIR}
        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
        ${other_TYPESYSTEM}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${libother_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}/..
                    ${sample_BINARY_DIR}
                    ${sample_BINARY_DIR}/sample
                    ${libshiboken_SOURCE_DIR})
add_library(other MODULE ${other_SRC})
set_property(TARGET other PROPERTY PREFIX "")
if(WIN32)
    set_property(TARGET other PROPERTY SUFFIX ".pyd")
endif()
target_link_libraries(other
                      libother
                      libsample
                      ${SBK_PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(other sample shiboken_generator)

=== tests/samplebinding/CMakeLists.txt ===
project(sample)

set(sample_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_sample.xml
)

set(sample_SRC
${CMAKE_CURRENT_BINARY_DIR}/sample/abstractmodifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/abstract_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base6_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/echo_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/event_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitconv_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitbase_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicittarget_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sortedoverload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intwrapper_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/injectcode_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/listuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mapuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/noimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/nondefaultctor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedenumclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicgranddaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedproperty_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedvirtualdestructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_okthisisrecursiveenough_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_derivedfromnamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/time_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualmethods_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/voidholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/valueandvirtual_wrapper.cpp
)

add_custom_command(OUTPUT ${sample_SRC}
COMMAND ${GENERATORRUNNER_BINARY} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
        --include-paths=${libsample_SOURCE_DIR}
        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}
        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
        ${sample_TYPESYSTEM}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${libsample_SOURCE_DIR}
                    ${libshiboken_SOURCE_DIR})
add_library(sample MODULE ${sample_SRC})
set_property(TARGET sample PROPERTY PREFIX "")
if(WIN32)
    set_property(TARGET sample PROPERTY SUFFIX ".pyd")
endif()
target_link_libraries(sample
                      libsample
                      ${SBK_PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(sample shiboken_generator)

=== debian/changelog ===
shiboken (0.5.0-0ubuntu1) maverick; urgency=low

  * New 0.5.0 upstream release (LP: #648612)
    - Bump libshiboken SOVERSION to 0.5
    - Add the new 0.5 symbols.

  * Patches
    - u_1eda671_fix_type_resolver_algorithm.patch
      (Remove, was from upstream)
    - u_46ab0d6_generated_original_name_with_star_for_object_classes.patch
      (Remove, was from upstream)
    + allowCustomShibokenPostfix.patch
      (Refresh)

  * Bump the apiextractor B-D.

 -- Didier Raboud <didier@raboud.com>  Mon, 27 Sep 2010 20:59:41 +0200

shiboken (0.4.0-1~exp1) experimental; urgency=low

  * Patches: 
    - u_46ab0d6_generated_original_name_with_star_for_object_classes.patch
      Import from upstream for bug #311.
    - u_1eda671_fix_type_resolver_algorithm.patch: Import from upstream for
      bug #243.

  * Bump libapiextractor B-D to 0.7.0-1~exp2, to correct qtgui_qwidget test
    segfault in pyside, together with the above patch.
  * Update symbols file.

  * Make sure DMUA is set (correct 0.3.2-1 changelog to match real uploads).

 -- Didier Raboud <didier@raboud.com>  Fri, 03 Sep 2010 10:29:27 +0200

shiboken (0.4.0-1~exp0) experimental; urgency=low

  * New 0.4.0 upstream release
    - Bump libshiboken SONAME to 0.4
    - Bump libapiextractor B-D to 0.7
    - Bump generatorrunner B-D to 0.6
    - Update install and symbol files

  * Patches:
    - u_4bab9a8_fix_Hurd_FTBFS.patch     Drop; was from upstream.
    - u_2f7c242_fidDebugBuild.patch      Drop; was from upstream.
    - u_1b40948_fix_protected_test.patch Drop; was from upstream.
    - use_original_sparsehash.patch      Drop; somehow included upstream.
    - fix_tests.patch                    Drop; no more needed.


 -- Didier Raboud <didier@raboud.com>  Wed, 04 Aug 2010 14:23:00 +0200

shiboken (0.3.2-3) unstable; urgency=low

  * Add allowCustomShibokenPostfix.patch to allow choice of python-specific
    version.

  * Remove custom cmake files in favour of cmake-data's.
    - Remove debian/cmake/*.
    - Bump cmake B-D to 2.8.2
    - Adapt debian/rules.
    - Update debian/copyright to remove the mentions of the hand-patched
      files.

  * Bump Standards to 3.9.0.0

 -- Didier Raboud <didier@raboud.com>  Thu, 22 Jul 2010 14:57:49 +0200

shiboken (0.3.2-2) unstable; urgency=low

  * Add debug-built versions to fix PySide's debug build
    - Import u_2f7c242_fidDebugBuild.patch from upstream
    - Add lintian overrides

  * Fix the Hurd FTBFS by importing u_4bab9a8_fix_Hurd_FTBFS.patch from
    upstream.

 -- Didier Raboud <didier@raboud.com>  Thu, 24 Jun 2010 16:49:50 +0200

shiboken (0.3.2-1) unstable; urgency=low

  [ Didier Raboud ]
  * New 0.3.2 upstream release
    - Bump B-D on apiextractor and generatorrunner.
    - Add {set,get}TypeUserData symbols.

  * Patches:
    - u_ftbfs_missing_file_44071543.patch: Remove, included upstream.
    - debian_buildoptions.patch: Remove, somehow included upstream.
    × Refresh others.

  * Make docs in binary-indep.

  [ Piotr Ożarowski ]
  * Set DMUA flag to yes

 -- Didier Raboud <didier@raboud.com>  Wed, 09 Jun 2010 12:11:42 +0200

shiboken (0.3.1-3) unstable; urgency=low

  * Patch upstream CMakeLists.txt to use the provided buildflags
    - Drop ftbfs_mips.patch
    - Add debian_buildoptions.patch
    This should fix the mips{,el} FTBFSes.

 -- Didier Raboud <didier@raboud.com>  Fri, 28 May 2010 13:16:16 +0200

shiboken (0.3.1-2) unstable; urgency=low

  * shiboken depends on generatorrunner (Closes: #581215)

  * Fix various FTBFSes:
    - On mips{,el} by adding ftbfs_mips.patch to use
      hash-style=both on all arches.
    - On ia64, powerpc and s390 by stealing
      u_ftbfs_missing_file_44071543.patch from upstream to fix
      declaration of class SimpleFile.

 -- Didier Raboud <didier@raboud.com>  Thu, 27 May 2010 18:02:34 +0200

shiboken (0.3.1-1) unstable; urgency=low

  * New 0.3.1 upstream release
    - Bump libshiboken SONAME to 0.3
    - Update symbols
    - Upload to unstable as dpkg-dev is now available
  * Patches
    + use_soname_from_version.patch:  remove, incorporated upstream.

 -- Didier Raboud <didier@raboud.com>  Thu, 06 May 2010 11:59:58 +0200

=== debian/control ===
Source: shiboken
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: Didier Raboud <didier@raboud.com>
Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 7.3.12), cmake (>= 2.8.2),
	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.8.0), generatorrunner (>= 0.6.1), libgenrunner-dev (>= 0.6.1),
	libsparsehash-dev (>= 1.6),
	python-all-dev, python-all-dbg
Build-Depends-Indep: python-sphinx
XS-Python-Version: >= 2.5
Standards-Version: 3.9.0.0
Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
Homepage: http://www.pyside.org/
DM-Upload-Allowed: yes

Package: shiboken
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.4.2)
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: shiboken-doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Section: doc
Description: CPython bindings generator for C++ libraries documentation
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings; this
 package contains its documentation.

Package: libshiboken0.5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0.5 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the development files for the library.

Package: shiboken-dbg
Section: debug
Architecture: any
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends},
         libshiboken0.5 (= ${binary:Version}),
         shiboken (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the debugging symbols for shiboken and libshiboken.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure_dbg-%) $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \
	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION=$* \
	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build_dbg-%) $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

override_dh_compress:
	dh_compress -X.js

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install_dbg-%) $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=_d.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test_dbg-%) $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: prepare_debug_test-%
	- dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_debug_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/samplebinding/sample.so )

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf doc/_build
	rm -rf debian/tmp-dbg

#### DEBIAN INSTALL ####

override_dh_install: override_dh_install_done

override_dh_install_real:
	# Install the debug variant
	dh_install --sourcedir=debian/tmp-dbg -pshiboken-dbg
	
	# Install the other variants
	dh_install --list-missing --remaining-packages

override_dh_install_done: override_dh_install_real
	# Setup the default version symbolic links
	$(shell ln -sf libshiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/shiboken/usr/lib/generatorrunner/libshiboken_generator.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/libshiboken-dev/usr/lib/libshiboken.so )
	# Setup the debug default version symbolic links
	$(shell ln -sf libshiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/generatorrunner/libshiboken_generator_d.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/libshiboken_d.so )

#### Shared libs ####
override_dh_makeshlibs:
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -Nshiboken

#### Docs ####
binary: binary-arch binary-indep;

binary-indep: binary-arch
	# Build docs
	make -C doc html
	dh binary-indep

## shiboken 0.5.0-1maemo2

=== tests/libsample/CMakeLists.txt ===
project(libsample)

set(libsample_SRC
abstract.cpp
blackbox.cpp
bucket.cpp
collector.cpp
complex.cpp
derived.cpp
echo.cpp
functions.cpp
implicitconv.cpp
injectcode.cpp
listuser.cpp
modifications.cpp
mapuser.cpp
multiple_derived.cpp
objecttype.cpp
objecttypelayout.cpp
objectview.cpp
overload.cpp
overloadsort.cpp
pairuser.cpp
point.cpp
polygon.cpp
protected.cpp
reference.cpp
samplenamespace.cpp
simplefile.cpp
size.cpp
sometime.cpp
str.cpp
strlist.cpp
virtualmethods.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions("-DLIBSAMPLE_BUILD")
add_library(libsample SHARED ${libsample_SRC})
set_property(TARGET libsample PROPERTY PREFIX "")

=== debian/changelog ===
shiboken (0.5.0-1maemo2) unstable; urgency=low

  * Bump version to workaround autobuilder issue.

 -- Willer Moreira <willer.moreira@openbossa.org>  Thu, 16 Sep 2010 11:16:51 -0400

shiboken (0.5.0-1maemo1) unstable; urgency=low

  * New upstream release.

 -- Willer Moreira <willer.moreira@openbossa.org>  Mon, 13 Sep 2010 14:16:51 -0400

=== debian/control ===
Source: shiboken
Section: devel
Priority: extra
Maintainer: PySide Team <pyside@openbossa.org>
XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.8.0), generatorrunner (>= 0.6.1), libgenrunner-dev (>= 0.6.1),
	python-all-dev, python-all-dbg
XS-Python-Version: >= 2.5
Standards-Version: 3.8.4
Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
Homepage: http://www.pyside.org/

Package: shiboken
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: libshiboken0.5
Section: libs
Architecture: any
Conflicts: libshiboken0 (<< 0.5)
Replaces: libshiboken0 (<< 0.5)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0.5 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the development files for the library.

Package: shiboken-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libshiboken0.5 (= ${binary:Version}),
         shiboken (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the debugging symbols for shiboken and libshiboken0.

=== debian/rules ===
#!/usr/bin/make -f

# Allow to find Qt 4.6 on Maemo
PATH := /usr/bin/dh7:$(PATH)
export PATH

%:
	dh --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
	-DCMAKE_PYTHON_VERSION="$*-dbg;$*" \
	-DCMAKE_PYTHONLIB_VERSION="$*_d;$*" \
	-DBUILD_TESTS=FALSE \
	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
	-DCMAKE_PYTHON_VERSION=$* \
	-DCMAKE_PYTHONLIB_VERSION=$* \
	-DBUILD_TESTS=FALSE \
	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=_d.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: 
	dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg

#### DEBIAN INSTALL ####

override_dh_install:
	# Install symlinks for default version
	$(shell ln -s shiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	              debian/tmp/usr/lib/generatorrunner/shiboken_generator.so )
	$(shell ln -s libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	              debian/tmp/usr/lib/libshiboken.so )
	dh_install --list-missing

#### Shared libs ####
override_dh_makeshlibs:
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -Nshiboken

## shiboken 0.5.1

=== debian/changelog ===
shiboken (0.5.1-3) unstable; urgency=low

  * Update symbols for GCC-4.5 and python2.7 (LP: #675729).

 -- Didier Raboud <didier@raboud.com>  Wed, 17 Nov 2010 19:11:12 +0100

shiboken (0.5.1-2) unstable; urgency=low

  * Fix convenience symlinks (Closes: #603088)

 -- Didier Raboud <didier@raboud.com>  Wed, 10 Nov 2010 22:34:53 +0100

shiboken (0.5.1-1) unstable; urgency=low

  * New 0.5.1 minor upstream release
    - Update symbols
    - Bump apiextractor and generatorrunner B-D versions
    - Update patches.
    - Update the documentation building process.
  
  * Bump Standards version to 3.9.1.0

 -- Didier Raboud <didier@raboud.com>  Tue, 19 Oct 2010 20:59:49 +0200

shiboken (0.5.0-1) UNRELEASED; urgency=low

  * New 0.5.0 upstream release
    - Bump libshiboken SOVERSION to 0.5
    - Add the new 0.5 symbols.

  * Patches
    - u_1eda671_fix_type_resolver_algorithm.patch
      (Remove, was from upstream)
    - u_46ab0d6_generated_original_name_with_star_for_object_classes.patch
      (Remove, was from upstream)
    + allowCustomShibokenPostfix.patch
      (Refresh)

  * Bump the apiextractor B-D.

 -- Didier Raboud <didier@raboud.com>  Sun, 26 Sep 2010 23:48:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,23 @@
 Source: shiboken
 Section: devel
-Priority: extra
-Maintainer: PySide Team <pyside@openbossa.org>
-XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.8.0), generatorrunner (>= 0.6.1), libgenrunner-dev (>= 0.6.1),
+Priority: optional
+Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+Uploaders: Didier Raboud <didier@raboud.com>
+Build-Depends: dpkg-dev (>= 1.15.7), debhelper (>= 7.3.12), cmake (>= 2.8.2),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.8.1), generatorrunner (>= 0.6.2), libgenrunner-dev (>= 0.6.2),
+	libsparsehash-dev (>= 1.6),
 	python-all-dev, python-all-dbg
+Build-Depends-Indep: python-sphinx
 XS-Python-Version: >= 2.5
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1.0
 Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
 Homepage: http://www.pyside.org/
+DM-Upload-Allowed: yes
 
 Package: shiboken
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.2)
 Description: CPython bindings generator for C++ libraries
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -23,11 +26,22 @@
  .
  Shiboken is the binding generator used to create the PySide bindings.
 
+Package: shiboken-doc
+Architecture: all
+Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
+Section: doc
+Description: CPython bindings generator for C++ libraries documentation
+ Shiboken is a bindings generator for C++ libraries that outputs CPython
+ source code. It uses generatorrunner and apiextractor to collect information
+ from library headers, merging modifications and handwritten code defined in the
+ typesystem description.
+ .
+ Shiboken is the binding generator used to create the PySide bindings; this
+ package contains its documentation.
+
 Package: libshiboken0.5
 Section: libs
 Architecture: any
-Conflicts: libshiboken0 (<< 0.5)
-Replaces: libshiboken0 (<< 0.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
@@ -52,6 +66,7 @@
 Package: shiboken-dbg
 Section: debug
 Architecture: any
+Priority: extra
 Depends: ${shlibs:Depends}, ${misc:Depends},
          libshiboken0.5 (= ${binary:Version}),
          shiboken (= ${binary:Version})
@@ -61,4 +76,4 @@
  from library headers, merging modifications and handwritten code defined in the
  typesystem description.
  .
- This package contains the debugging symbols for shiboken and libshiboken0.
+ This package contains the debugging symbols for shiboken and libshiboken.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure_dbg-%) $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \
	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION=$* \
	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build_dbg-%) $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

override_dh_compress:
	dh_compress -X.js

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install_dbg-%) $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=_d.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test_dbg-%) $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: prepare_debug_test-%
	- dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_debug_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/samplebinding/sample.so )

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg

#### DEBIAN INSTALL ####

override_dh_install: override_dh_install_done

override_dh_install_real:
	# Install the debug variant
	dh_install --sourcedir=debian/tmp-dbg -pshiboken-dbg
	
	# Install the other variants
	dh_install --list-missing --remaining-packages

override_dh_install_done: override_dh_install_real
	# Setup the default version symbolic links
	$(shell ln -sf shiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/shiboken/usr/lib/generatorrunner/shiboken_generator.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/libshiboken-dev/usr/lib/libshiboken.so )
	# Setup the debug default version symbolic links
	$(shell ln -sf shiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/generatorrunner/shiboken_generator_d.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/libshiboken_d.so )

#### Shared libs ####
override_dh_makeshlibs:
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -Nshiboken

#### Docs ####
binary: binary-arch binary-indep;

binary-indep: binary-arch
	dh binary-indep --until dh_auto_build
	dh_auto_build -i --builddirectory=build-$(DEFAULT_PY) -- doc
	dh binary-indep --after dh_auto_build

=== debian/watch ===
version=3
http://www.pyside.org/files/shiboken-([\d\.]*).tar.bz2
